import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.net.*;
import java.io.*;

/**
 * standard Graphics application
 */
public class Simulation extends JApplet {
  	private Thread mapThread;
	private Model mySolution;
        private boolean isStandalone = false;
/**
 *   basic constructor
*/
  public void init() {
	EventHandler eh;
	JButton b;

    // initialize global storage    
    Global.init(isStandalone);    
    
    // build the button panel
    JPanel stpanel = new JPanel();
    stpanel.setLayout(new FlowLayout());
    b = new JButton( "Start" );
    eh = new EventHandler (this, b);
    b.addMouseListener(eh);
    stpanel.add(b);
    b = new JButton( "Stop" );
    eh = new EventHandler (this, b);
    b.addMouseListener(eh);
    stpanel.add(b);
    int nbts = Model.Labels.length;
    for(int i = 0; i < nbts; i++ ) {
	    b = new JButton( Model.Labels[i] );
	    eh = new EventHandler (this, b);
	    b.addMouseListener(eh);
	    stpanel.add(b);
    }
    
    // buuld the container
    Container cp = getContentPane();
    cp.setLayout(new BorderLayout());
    mySolution = new Model();
    Global.myPanel = new MyPanel(mySolution);
    cp.add( Global.myPanel, BorderLayout.CENTER );
    cp.add( stpanel, BorderLayout.SOUTH );
  }

/**
 *   Event handler for mouse clicks
*/
  class EventHandler implements MouseListener {  
    Simulation theFrame; 
    JButton button;
    
    public EventHandler (Simulation theFrame, JButton button) {
	     this.theFrame = theFrame;
	     this.button  = button;
    }

    public void mouseClicked(MouseEvent e) {
      String com = button.getText();
      if (com.equals("Start")) {
      	if(!Global.myPanel.isRunning) {
			mapThread = new Thread(Global.myPanel);
			Global.myPanel.isRunning = true;
			mapThread.start();
		}
      } else if (com.equals("Stop")) {
			Global.myPanel.stop();
      } else {
	      int i = 0;
	      for(; i < mySolution.Labels.length; i++ ) {
                            if (com.equals(mySolution.Labels[i])) {
                                    mySolution.doButton(i);
                                    repaint();
                                    break;
                            }	 
	      		}
		  if (i == mySolution.Labels.length) {
				System.out.println( "Erroneous Action" );
		  }
	  }
    }
    public void mousePressed(MouseEvent e) {}
    public void mouseEntered(MouseEvent e) {}
    public void mouseExited(MouseEvent e)  {}
    public void mouseReleased(MouseEvent e){}
    
   } 
	/**
	 * main program
	 * @param s who knows
	 */
	public static void main(String[] s) {
	 	JFrame frame = new JFrame(Model.title);
                frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
                frame.setSize(800, 600);
                Simulation app = new Simulation();
                frame.add(app, BorderLayout.CENTER);
                app.isStandalone = true;
                app.init();
                frame.setLocation (10,10);
                frame.setVisible(true);
	}
}  // GraphicApp