// Wolf.java

import java.awt.*;
import java.util.LinkedList;

public class Wolf extends Agent {
  // data
  public double speed;
  private int timer;
  
  public Wolf() {
    color = new Color(180, 180, 180);
    radius = 10;
    foundOne = false;
    speed = 4;
    nature = WOLF;
    timer = 120;
  }
  
  public void update(LinkedList<Agent> lst) {
    switch(state) {
      case HUNGRY:
        nearestThing(lst, DEER, 200);
        if(foundOne) {
          double dx = targetX - x;
          double dy = targetY - y;
          double dist = Math.sqrt(dx*dx + dy*dy);
          if(dist < radius) {
            state = NORMAL;
            timer = 120;
            if(target != null) target.state = DEAD;
          } else {
            double th = Math.atan2(dy, dx);
            x += speed * Math.cos(th);
            y += speed * Math.sin(th);
          }
        } else {
          if(timer-- <= 0) {
            state = DEAD;
          }
        }
        super.update(lst);
        break;
      case NORMAL:
        super.update(lst);
        if(timer-- <= 0) {
          state = HUNGRY;
          timer = 300;
        }
        break;
      case DEAD:
        color = Color.BLACK;
        break;
    }
  }
  
  public void draw(Graphics g) {
    super.draw(g);
    switch(state) {
      case HUNGRY:
        g.setColor(Color.RED);
        g.fillOval( (int) x - radius/2, (int) y - radius/2, radius, radius);
        break;
    }
  }
}